## emacs25 25.1+1

=== modules/mod-test/Makefile ===
# Test GNU Emacs modules.

# Copyright 2015-2016 Free Software Foundation, Inc.

# This file is part of GNU Emacs.

# GNU Emacs is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# GNU Emacs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs.  If not, see <http://www.gnu.org/licenses/>.

ROOT = ../..
EMACS = $(ROOT)/src/emacs

CC      = gcc
LD      = gcc
LDFLAGS =

# On MS-Windows, say "make SO=dll" to build the module
SO      = so
# -fPIC is a no-op on Windows, but causes a compiler warning
ifeq ($(SO),dll)
CFLAGS  = -std=gnu99 -ggdb3 -Wall
else
CFLAGS  = -std=gnu99 -ggdb3 -Wall -fPIC
endif

all: mod-test.$(SO)

%.$(SO): %.o
	$(LD) -shared $(LDFLAGS) -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -I$(ROOT)/src -c $<

check:
	$(EMACS) -batch -l ert -l test.el -f ert-run-tests-batch-and-exit

=== test/etags/Makefile ===
ADASRC=$(addprefix ./ada-src/,etags-test-for.ada 2ataspri.adb 2ataspri.ads waroquiers.ada)
ASRC=$(addprefix ./a-src/,empty.zz empty.zz.gz)
CSRC=$(addprefix ./c-src/,abbrev.c .//c.c torture.c getopt.h etags.c\
 exit.c exit.strange_suffix sysdep.h tab.c dostorture.c\
 emacs/src/gmalloc.c emacs/src/regex.h emacs/src/keyboard.c emacs/src/lisp.h\
 machsyscalls.c machsyscalls.h fail.c a/b/b.c) ../etags/c-src/h.h
CPSRC=$(addprefix ./cp-src/,c.C x.cc burton.cpp burton.cpp\
 functions.cpp MDiagArray2.h Range.h\
 screen.cpp screen.hpp conway.cpp conway.hpp clheir.cpp.gz clheir.hpp.gz fail.C)
ELSRC=$(addprefix ./el-src/,TAGTEST.EL emacs/lisp/progmodes/etags.el)
ERLSRC=$(addprefix ./erl-src/,gs_dialog.erl)
FORTHSRC=$(addprefix ./forth-src/,test-forth.fth)
FSRC=$(addprefix ./f-src/,entry.for entry.strange_suffix entry.strange)
GOSRC=$(addprefix ./go-src/,test.go test1.go)
HTMLSRC=$(addprefix ./html-src/,softwarelibero.html index.shtml algrthms.html software.html)
#JAVASRC=$(addprefix ./java-src/, )
LUASRC=$(addprefix ./lua-src/,allegro.lua test.lua)
MAKESRC=$(addprefix ./make-src/,Makefile)
OBJCSRC=$(addprefix ./objc-src/,Subprocess.h Subprocess.m PackInsp.h PackInsp.m)
OBJCPPSRC=$(addprefix ./objcpp-src/,SimpleCalc.H SimpleCalc.M)
PASSRC=$(addprefix ./pas-src/,common.pas)
PERLSRC=$(addprefix ./perl-src/,htlmify-cystic yagrip.pl kai-test.pl)
PHPSRC=$(addprefix ./php-src/,lce_functions.php ptest.php sendmail.php)
PSSRC=$(addprefix ./ps-src/,rfc1245.ps)
PROLSRC=$(addprefix ./prol-src/,ordsets.prolog natded.prolog)
PYTSRC=$(addprefix ./pyt-src/,server.py)
RBSRC=$(addprefix ./ruby-src/,test.rb test1.ru)
TEXSRC=$(addprefix ./tex-src/,testenv.tex gzip.texi texinfo.tex nonewline.tex)
YSRC=$(addprefix ./y-src/,parse.y parse.c atest.y cccp.c cccp.y)
SRCS=${ADASRC} ${ASRC} ${CSRC} ${CPSRC} ${ELSRC} ${ERLSRC} ${FSRC}\
     ${FORTHSRC} ${GOSRC} ${HTMLSRC} ${JAVASRC} ${LUASRC} ${MAKESRC}\
     ${OBJCSRC} ${OBJCPPSRC} ${PASSRC} ${PHPSRC} ${PERLSRC} ${PSSRC}\
     ${PROLSRC} ${PYTSRC} ${RBSRC} ${TEXSRC} ${YSRC}
NONSRCS=./f-src/entry.strange ./erl-src/lists.erl ./cp-src/clheir.hpp.gz

ETAGS_PROG=../../lib-src/etags
CTAGS_PROG=../../lib-src/ctags

REGEX=/[ \t]*DEFVAR_[A-Z_ \t\n(]+"\([^"]+\)"/
xx="this line is here because of a fontlock bug

RUN=

OPTIONS=--members --declarations --regex=@regexfile
ARGS=- < srclist

infiles = $(filter-out ${NONSRCS},${SRCS}) srclist regexfile

.PHONY: check cdiff ETAGS CTAGS
# Can't make ediff_1 through ediff_5 .PHONY, as they're implicit.

check:
	@$(MAKE) OPTIONS='--no-members' ediff_1
	@$(MAKE) OPTIONS='--declarations --no-members' ediff_2
	@$(MAKE) OPTIONS='--members' ediff_3
	@$(MAKE) OPTIONS='--regex=@regexfile --no-members' ediff_4
	@$(MAKE) OPTIONS='nonexistent --members --declarations --regex=@regexfile' ediff_5
	@$(MAKE) OPTIONS='--class-qualify --members --declarations --regex=@regexfile' ediff_6
	@$(MAKE) cdiff

ediff%: ETAGS.good% ETAGS ${infiles}
	diff -u --suppress-common-lines --width=80 ETAGS.good$* ETAGS

cdiff: CTAGS.good CTAGS ${infiles}
	diff -u --suppress-common-lines --width=80 CTAGS.good CTAGS

ETAGS: ${infiles}
	${RUN} ${ETAGS_PROG} ${OPTIONS} -o $@ ${ARGS}

CTAGS: ${infiles}
	${RUN} ${CTAGS_PROG} -o $@ --regex=@regexfile ${ARGS}

srclist: Makefile
	@for i in $(SRCS); do echo $$i; done > srclist
	@echo "srclist remade"

regexfile: Makefile
	@echo '	-- This is for GNU Emacs source files' > regexfile
	@printf '%s\n' '${REGEX}' >> regexfile
	@printf '%s\n' '{c}${REGEX}\\1/m' >> regexfile
	@echo "regexfile remade"

=== debian/changelog ===
emacs25 (25.1+1-4+deb9u1) stretch-security; urgency=high

  * Block remote code execution via enriched text.  Add
    0012-A-remote-execution-exploit-via-enriched-text-has-bee.patch to
    fix the problem.  Thanks to David Bremner for the alert and
    Salvatore Bonaccorso for reporting the problem to Debian.
    (Closes: 875447)

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 13 Sep 2017 01:33:28 -0500

emacs25 (25.1+1-4) unstable; urgency=medium

  * Don't offer/use openssl s_client by default: "s_client is a debug
    tool, it does not set up a secure connection, it ignores all
    errors and just continues.  It also doesn't do checks it should be
    doing.  This is all documented behaviour." -- Kurt Roeckx
    Add 0009-openssl-s_client-is-no-longer-a-default-for-ssl-conn.patch to
    fix the problem.  Thanks to Kurt Roeckx for reporting the issue.
    (Closes: 766397)

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 23 Apr 2017 11:49:52 -0500

emacs25 (25.1+1-3) unstable; urgency=medium

  * Configure with REL_ALLOC=no to fix crashes.  Thanks to Santiago
    Vila for reporting the problem, and Sean Whitton for helping test
    the fix. (Closes: 842728)

  * Disable xwidget (webkit) support.  Thanks to David Bremner for
    reporting the issue. (Closes: 843462)

  * Depend on liboss4-salsa-dev on hurd and kfreebsd.  Thanks to Aaron
    M. Ucko for reporting the problem and Svante Signell for providing
    the fix. (Closes: 840702)

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 30 Nov 2016 18:15:33 -0600

emacs25 (25.1+1-2) unstable; urgency=medium

  * Respect DEB_BUILD_OPTIONS=nocheck.  Thanks to David Bremner for
    reporting the issue.

  * Don't dh_auto_clean, and run dh_clean first.  Since we don't build
    in the source tree, we shouldn't clean there either, and let
    dh_clean take care of its bits before we stomp around.

  * Install emacs.appdata.xml as emacs25.appdata.xml.

  * Drop emacs23 icons to avoid future path conflicts.  Thanks to
    Tatsuya Kinoshita for reporting the problem. (Closes: 841687)

  * Fix fix for package-test gpg-agent cleanup race.  Specify
    --no-autostart so that we don't start an agent if one wasn't
    already running when we're requesting shutdown, and delete the
    test dir with "rm -rf" to avoid being affected by vanishing
    sockets (sockets that gpg-agent may be deleting in parallel).

  * Add gnupg-agent build-dep for package-test.

  * Don't segfault if gcc expects -nopie instead of -no-pie.  Thanks
    to Lucas Nussbaum and Aaron M. Ucko for reporting the problem, and
    Sven Joachim for tracking down the upstream patch. (Closes:
    841551)

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 24 Oct 2016 13:10:40 -0500

emacs25 (25.1+1-1) unstable; urgency=medium

  * Merge upstream version 25.1.
    Remove patches that are no longer needed:
      0006-Look-for-NEWS-in-order-to-find-etc-rather-than-GNU.patch
      0008-Emacs-won-t-assume-grep-supports-GREP_OPTIONS.patch
      0009-Emacs-should-no-longer-hang-during-large-yanks.patch
      0010-ELF-unexec-Correct-section-header-index.patch
      0011-ELF-unexec-Tidy-code.patch
      0012-ELF-unexec-Merge-Alpha-and-MIPS-COFF-debug-handling.patch
      0013-ELF-unexec-Symbol-table-patching.patch
      0014-ELF-unexec-_OBJC_-symbols-in-bss-sections.patch
      0015-ELF-unexec-R_-_NONE-relocs.patch
      0016-ELF-unexec-Drive-from-PT_LOAD-header-rather-than-sec.patch
      0017-ELF-unexec-Don-t-insert-a-new-section.patch
      0018-src-unexelf.c-NEW_PROGRAM_H-Remove-unused-macro-Bug-.patch
      0019-ELF-unexec-align-section-header.patch
      0020-Emacs-should-show-GTK-icons-again.patch
      0021-Emacs-should-work-with-gcc-5.2-and-newer.patch
      0022-Emacs-should-work-with-glibc-2.24-on-ppc64.patch

  * debian/upstream-version: update regex for 25.1.

  * debian/.gitignore: update for 25.1.

  * debian/changelog: change the package name to emacs25.

  * debian/copyright.in: change source archive extension to xz.

  * Update debian control and copyright for 25.1.

  * Stop mangling info files.

  * debian/rules: clean additional files for 25.1.

  * Don't copy missing-file.dfsg to THE-GNU-PROJECT.  THE-GNU-PROJECT
    is now compatible with the DFSG.  Remove missing-file.dfsg
    entirely since it it no longer being used.

  * Bump Debian alternatives priority to 28 for 25.1.

  * Remove ia64 CFLAGS "-O1" workaround.

  * Compute version in strip-nondeterminism fix.  Use $(runtime_ver)
    and $(flavor) instead of 24.5 and emacs24.

  * Fix dh_listpackages in strip-nondeterminism target.

  * Set libmagick build-dep to libmagick++-6.q16-dev.

  * debian/setup-stamp: remove redundant mkdir.

  * Don't default to ALSA support; explicitly request it.

  * Run tests in all three debian/ build trees.

  * Enable xwidget (webkit) support for emacs25.

  * Convert debian/copyright to 1.0; update for 25.1.  Explicitly
    mention the unusual debian/rules copyright, which will be
    addressed via #826347.

  * Add dbus-x11 and procps build-deps for tests.

  * Kill gpg agent in package-test.el to avoid a race.  Add
    0007-Kill-gpg-agent-in-package-test.el-to-avoid-a-race.patch to
    incorporate the fix.

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 10 Oct 2016 21:54:59 -0500

emacs24 (24.5+1-7) unstable; urgency=medium

  * debian/control: make Source-Version source:Version.  Thanks to
    Guillem Jover for reporting the problem. (Closes: 833215)

  * Restore GTK+ toolbar icons.
    Add 0020-Emacs-should-show-GTK-icons-again.patch to include the relevant
    upstream code.  Thanks to Juerg Haefliger for reporting the problem and
    pointing out the relevant upstream commit. (Closes: 828000)

  * Fix malloc handling with newer gcc (>= 5.2).
    Add 0021-Emacs-should-work-with-gcc-5.2-and-newer.patch to incorporate
    the relevant upstream code.  Thanks to Aurelien Jarno for reporting the
    problem and backporting the fix.

  * Support glibc 2.24.


=== debian/control ===
Source: emacs25
Section: editors
Priority: optional
Maintainer: Rob Browning <rlb@defaultvalue.org>
Build-Depends: bsd-mailx | mailx, libncurses5-dev, texinfo, liblockfile-dev, librsvg2-dev,
 dbus-x11,
 gnupg-agent,
 libgif-dev | libungif4-dev,
 libtiff-dev,
 procps,
 xaw3dg-dev,
 libpng-dev, libjpeg-dev, libm17n-dev, libotf-dev,
 libgpm-dev [linux-any], libdbus-1-dev,
 autoconf, automake, autotools-dev, dpkg-dev (>> 1.10.0), quilt (>= 0.42),
 debhelper (>= 9), libxaw7-dev, sharutils, imagemagick, libgtk-3-dev,
 libgnutls28-dev, libxml2-dev, libselinux1-dev [linux-any],
 libgconf2-dev, libasound2-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
 libmagick++-6.q16-dev,
 libacl1-dev,
 liboss4-salsa-dev [hurd-i386 kfreebsd-i386 kfreebsd-amd64],
 zlib1g-dev
Homepage: http://www.gnu.org/software/emacs/
Standards-Version: 3.7.2

Package: emacs25-lucid
Architecture: any
Depends: emacs25-bin-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: emacs25, emacsen, editor, info-browser, mail-reader, news-reader
Suggests: emacs25-common-non-dfsg
Conflicts: emacs25, emacs25-nox
Replaces: emacs25, emacs25-nox
Description: GNU Emacs editor (with Lucid GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with support for a graphical user
 interface based on the Lucid toolkit (instead of the GTK+ interface
 provided by the emacs25 package).  Until some known GTK+
 problems are fixed, this version may help avoid crashing Emacs during
 an emacsclient disconnect.  See
 https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=567934 and
 https://bugzilla.gnome.org/show_bug.cgi?id=85715 for more
 information.

Package: emacs25-lucid-dbg
Section: debug
Priority: extra
Architecture: any
Depends: emacs25-lucid-dbg (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs25-lucid
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs25-lucid
 package.

Package: emacs25-nox
Architecture: any
Depends: emacs25-bin-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: emacs25, editor, emacsen, info-browser, mail-reader, news-reader
Suggests: emacs25-common-non-dfsg
Conflicts: emacs25, emacs25-lucid
Replaces: emacs25, emacs25-lucid
Description: GNU Emacs editor (without GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs compiled without support for X,
 and provides only a text terminal interface.

Package: emacs25-nox-dbg
Section: debug
Priority: extra
Architecture: any
Depends: emacs25-nox-dbg (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs25-nox
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs25-nox
 package.

Package: emacs25
Architecture: any
Depends: emacs25-bin-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: editor, emacsen, info-browser, mail-reader, news-reader
Suggests: emacs25-common-non-dfsg
Conflicts: emacs25-lucid, emacs25-nox
Replaces: emacs25-lucid, emacs25-nox
Description: GNU Emacs editor (with GTK+ GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with a graphical user interface
 based on GTK+ (instead of the Lucid toolkit provided by the
 emacs25-lucid package).

Package: emacs25-dbg
Section: debug
Priority: extra
Architecture: any
Depends: emacs25-dbg (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs25
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs25 package.

Package: emacs25-bin-common
Architecture: any
Depends: emacs25-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: GNU Emacs editor's shared, architecture dependent files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture dependent infrastructure
 that's shared by emacs25, emacs25-lucid, and emacs25-nox.

Package: emacs25-common
Architecture: all
Depends: emacsen-common (>= 2.0.8), dpkg (>= 1.15.4) | install-info, ${shlibs:Depends}, ${misc:Depends}
Recommends: emacs25-el
Suggests: emacs25-el, emacs25-common-non-dfsg, ncurses-term
Conflicts: emacs25-el (<< ${source:Version}), cedet, eieio, speedbar, gnus-bonus-el
Breaks: apel (<< 10.8+0.20120427-4)
Description: GNU Emacs editor's shared, architecture independent infrastructure
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture independent infrastructure
 that's shared by emacs25, emacs25-lucid, and emacs25-nox.

Package: emacs25-el
Architecture: all
Depends: emacs25-common (= ${source:Version}), ${misc:Depends}
Description: GNU Emacs LISP (.el) files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the elisp sources for the convenience of users,
 saving space in the main package for small systems.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This file is licensed under the terms of the Gnu Public License.
# With the one additional provision that Ian Jackson's name may not be
# removed from the file.

# Copyright 1994,1995 Ian Jackson
# Copyright 2004-2005 Jrme Marant <jerome@debian.org>
# Copyright 1998-2015 Rob Browning <rlb@defaultvalue.org>

# Originally copied from the GNU Hello Debian rules file (1.3).
# Modified for emacs by Mark Eichin <eichin@kitten.gen.ma.us>.
# Debhelper support added via one of Joey Hess' example files.
# See the debian/changelog for further historical information.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SHELL := /bin/bash
quilt := QUILT_PATCHES=debian/patches QUILT_PATCHES_PREFIX=y quilt
pf := set -o pipefail

# This package uses debian/source/format 3.0 (quilt).

# For now we assume that emacs' versioning scheme is always
# MAJOR.MINORtinyrev where MAJOR and MINOR are integers and tinyrev is
# an optional lowercase letter (or letters).  We also assume that
# upstream uses a numbering scheme that sorts in a "Debian friendly"
# way.  So far that's always been true.  If it becomes false, some of
# the values below will have to be set manually.

# (You might imagine that a VPATH build would allow us to avoid having
#  to copy the entire source tree for each of the three builds, but it
#  turns out that without additional complexity, VPATH builds will
#  cause diff bloat.  That's because the emacs build process doesn't
#  completely respect the .elc files; some are modified in srcdir, not
#  builddir.)

# The official upstream version defined by AC_INIT in configure.in.
upstream_ver := $(shell debian/upstream-version)
ifeq (,$(upstream_ver))
  $(error 'Unable to find upstream version number.')
endif

# This must be the version that's actually used at runtime for things
# like load-path.  It may not be the same as the upstream version
# (i.e. when you have upstream 20.5a, the functional version may still
# be 20.5), so sometimes we may have to do this by hand.
runtime_ver := $(shell $(pf); echo $(upstream_ver) | perl -pe 's/[a-z]+$$//o')
major_ver := $(shell $(pf); echo $(runtime_ver) | perl -pe 's/\..*$$//o')
minor_ver := $(shell $(pf); echo $(runtime_ver) | perl -pe 's/^[^.]*\.//o')

# The name of the Debian source package
src_name := $(shell $(pf); dpkg-parsechangelog | egrep '^Source:')
src_name := $(shell $(pf); echo $(src_name) | perl -pe 's/Source:\s+//o')

# The version from the changelog (i.e. 20.5-1)
debian_ver := $(shell $(pf); dpkg-parsechangelog | egrep '^Version:')
debian_ver := $(shell $(pf); echo $(debian_ver) | perl -pe 's/Version:\s+//o')

# The Debian revision (i.e. the 1 from 20.5-1)
# Always everything after the last '-'
debian_rev := $(shell $(pf); echo $(debian_ver) | perl -pe 's/.*-//o')

# Might be 21.3, or it might be 21.3+1 if we've had to have more than
# one re-release of the upstream source (rare, but it happens), or if
# we have to split the package for DFSG purposes.  Always everything
# before the last '-'
debsrc_ver := $(shell $(pf); echo $(debian_ver) | perl -pe 's/-[^-]+$$//o')

# The flavor (i.e. emacs21) currently matches the source package name.
flavor := $(src_name)

info_subdir := emacs-$(major_ver)

######################################################################
# Customizable variables

bin_priority := 28

# This might also be something like 2006-09-09 for snapshots.
menu_ver := $(major_ver)

######################################################################

# Should these be exported like this (as autotools-dev recommends for
# the two vars below) or not?
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)

# As recommended by /usr/share/doc/autotools-dev/README.Debian.gz.
# Handle cross-compiling and don't make ./configure guess.
export DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# FOR AUTOCONF 2.52 AND NEWER ONLY
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --build $(DEB_HOST_GNU_TYPE)
else
  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

deb_host_multiarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
CFLAGS += -Wall
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)

joblimit := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq (,$(joblimit))
  joblimit := 1
endif

target := $(DEB_HOST_GNU_TYPE)
movemail_bin := usr/lib/emacs/$(runtime_ver)/$(target)/movemail

# Info files that are going to show up in the main dir.
main_dir_info_files := efaq.info

# Files that the build stage depends on (may also be listed in other vars).
persistent_autogen_build_files := debian/control debian/copyright
nonpersistent_autogen_build_files :=

# These files must always exist, i.e. can't ever be cleaned.
persistent_autogen_install_files :=

nonpersistent_autogen_install_files := \
  debian/$(flavor)-bin-common.lintian-overrides \
  debian/$(flavor)-bin-common.postinst \
  debian/$(flavor)-bin-common.prerm \
  debian/$(flavor)-common.README.Debian \
  debian/$(flavor)-common.docs \
  debian/$(flavor)-common.lintian-overrides \
  debian/$(flavor)-common.postinst \
  debian/$(flavor)-common.prerm \
  debian/$(flavor)-term.desktop \
  debian/$(flavor)-nox.README.Debian \
  debian/$(flavor)-nox.lintian-overrides \
  debian/$(flavor)-nox.postinst \
  debian/$(flavor)-nox.prerm \
  debian/$(flavor)-lucid.README.Debian \
  debian/$(flavor)-lucid.desktop \
  debian/$(flavor)-lucid.lintian-overrides \
  debian/$(flavor)-lucid.postinst \
  debian/$(flavor)-lucid.prerm \
  debian/$(flavor).README.Debian \
  debian/$(flavor).desktop \
  debian/$(flavor).lintian-overrides \
  debian/$(flavor).postinst \
  debian/$(flavor).prerm

autogen_build_files := \
  $(nonpersistent_autogen_build_files) $(persistent_autogen_build_files)

autogen_install_files := \
  $(nonpersistent_autogen_install_files) $(persistent_autogen_install_files)

persistent_autogen_files := \
  $(persistent_autogen_build_files) $(persistent_autogen_install_files)

nonpersistent_autogen_files := \
  $(nonpersistent_autogen_build_files) $(nonpersistent_autogen_install_files)


# Build directories
pkgdir_common := $(CURDIR)/debian/$(flavor)-common
pkgdir_bin_common := $(CURDIR)/debian/$(flavor)-bin-common
pkgdir_x := $(CURDIR)/debian/$(flavor)
pkgdir_nox := $(CURDIR)/debian/$(flavor)-nox
pkgdir_lucid := $(CURDIR)/debian/$(flavor)-lucid
pkgdir_el := $(CURDIR)/debian/$(flavor)-el

install_dir_x := $(CURDIR)/debian/install-x
install_dir_nox := $(CURDIR)/debian/install-nox
install_dir_lucid := $(CURDIR)/debian/install-lucid

local_lpath := /etc/$(flavor):/etc/emacs
local_lpath := $(local_lpath):/usr/local/share/emacs/$(runtime_ver)/site-lisp
local_lpath := $(local_lpath):/usr/local/share/emacs/site-lisp
local_lpath := $(local_lpath):/usr/share/emacs/$(runtime_ver)/site-lisp
local_lpath := $(local_lpath):/usr/share/emacs/site-lisp

# Installation local_lpath
local_lpath_install \
  := $(pkgdir_common)/$(subst :,:$(pkgdir_common)/,$(local_lpath))

define testdir
  dh_testdir debian/emacsVER.postinst
endef

# If we ever need to do the stripping outside of dh_strip, just add an
# INSTALL_STRIP="-s" to the make vars below.

define emacs_inst
  $(MAKE) -C debian/$(1) install \
    DESTDIR=$(2) \
    infodir=/usr/share/info/emacs-$(major_ver) \
    localstatedir=/var
endef

# If we ever need it, we can create a copy that doesn't assume ./debian/
define deb_sub
  perl -p \
    -e "s|\@PKG_NAME\@|$(pkg_name)|go;" \
    -e "s|\@MAJOR_VERSION\@|$(major_ver)|go;" \
    -e "s|\@MINOR_VERSION\@|$(minor_ver)|go;" \
    -e "s|\@FULL_VERSION\@|$(runtime_ver)|go;" \
    -e "s|\@PACKAGE_VERSION\@|$(debian_ver)|go;" \
    -e "s|\@DEBIAN_REV\@|$(deb_rev)|go;" \

## emacs25 25.1-1

=== debian/changelog ===
emacs25 (25.1-1) unstable; urgency=low

  * Initial release.

 -- Manan Tuli <mt_void@yahoo.com>  Tue, 20 Sep 2016 11:10:11 +0530

=== debian/control ===
Source: emacs25
Section: user/utilities
Priority: optional
Maintainer: Manan Tuli <mt_void@yahoo.com>
Build-Depends: debhelper (>= 7.0.0), autotools-dev, libncurses5-dev, libungif4-dev, libxml2-dev, libxpm-dev, libtiff4-dev, libgconf2-dev, libgtk2.0-dev
Standards-Version: 3.9.3
Homepage: https://www.gnu.org/software/emacs

Package: emacs25
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: emacs24
Conflicts: emacs24
Provides: editor, emacsen, info-browser, mail-reader, news-reader
Description: The GNU Emacs editor
 GNU Emacs is the extensible self-documenting text editor.
 This package contains a version of Emacs for the Maemo platform.
XSBC-Maemo-Display-Name: GNU Emacs
XSBC-Bugtracker: https://talk.maemo.org/showthread.php?t=88135
XB-Maemo-Upgrade-Description: GNU Emacs 25.1
 New upstream release
XB-Maemo-Icon-26:
 iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgI
 fAhkiAAAAAlwSFlzAAAN1wAADdcBQiibeAAAABl0RVh0U29mdHdhcmUAd3d3
 Lmlua3NjYXBlLm9yZ5vuPBoAAA2xSURBVGiBtVppjBzHdf6qunuOnvveY7i7
 5O5yl1xyecpkRAkwJUVyhFiSjyBInAOBksixAwdOEMB2fgT+lSBxEAMWEhhx
 rBhIgIQ5nEOyDEiCfJAMzUu8llrufXDP2bnvnu56+TEzu3Muh6RSQKMbXdtV
 3/feV++9qlmGj6axnWtMArIc0DjgZ+XuLQJMAvAZwDUBgGqux574cb7lwJDs
 9cIsSR71pP2JcVlWRxWmDDMmucGESgRBJLKGEFs6Fafzpcydq/ELkxaLVIxE
 oAET+uOQeRQCDIAEjJvHeoK+ver4Z+1m52c4TCcYkZkpsm52WEm2KIybFZkM
 IlHSDC1bEMVsTiLdkAhIlUTxfFZL/suNyPkfbmRiaeC+BqDqnf83AhIQsjwd
 fmEwaA9/2SzZf4VLXHbuCXBbt5fZgm5IZlP9F0Tb9iUilNJ5ZCMxJFcjRmY9
 wgSjVFZL/u189s63P1yb2wAWqkQ+UgIMGFP6/V7fcd9TX1EV+xdk1YLgwQHZ
 0RcEk3jzF1QLnkDU/M7QSogtrGBzak43dD2X1GJfvxJ7+7uJhC8LXKtK67EJ
 cKDH8uze588EbUNvyJISCh0fll39QYC1+bwGKNUARgsSRIDQdWzNLNLG9Czp
 pF+dy02/emv5g5lOvCE9CLzfP2J7pufTr/nV8D84e4KOvrNHZavP2Rp8A9Bm
 8PUkqHJn4LB53czd08Wy0XjISY5f73L4bi8kIktA2sAuntiNAPf7R2xnvC99
 zaX4vh46OiQFjw1x3kouTeBbS0biDIGgCqfThHxOhzBE3d/Isgxvby/XC0UT
 8uKzIUfP3EJi495uJNpJiAcCY+qTrhe/6jB7vtJz+iB39AXaU21jdVnmCIed
 6N/rRN+AC+E+J2SlbACtaODuzU28+z+zyGVKdZIjIqxPz9DG3KyIaVu/8ZPF
 d78P3C+0ItGKAAN6rC8O/tJveyzBb/acPsCcfaGOrW42Sdi7z4XBYS/6BpyQ
 ZA6LRQJjDGazBMbrp9xcy+I7f3UFuia2yTMCgYD79yaxeX9B2yotfvLC/Ac/
 AWa0RhItCIyZntl78nS3uv+dwPg+k2+0r2Pw7RZq2bKAInMcO9WNT7wyVDfU
 m/88iWsXVurAo+KJ+Ts3RDyyvjmVuv7k5PqP7gPQa79tFLTUZTe5Qrah76pd
 Xsk70g48Nbi8EXA9MQLB7lAwMOjG0IinabjuPQ4wYlQLvkIGe/Yf4opiCuy1
 Hfxrv3/E2ohZrnlmQNj0se7nviRxZaDnY6NSU6BpYXWrVYbbZYbdYYLFLMFk
 lmG3K3B5LHC5zXC6zHC5zZDkNosfQCapEURzxCICZC5hYPSINHXz0ssH7Mef
 /emW/ANgQmtFgI8Fjvc6zJ4/Co7vk2RLY0atsQwDTj0ZxpFjQQSCaltgnbS1
 pRQuv7/cNsSCAIfTA4+/m4yo+HOXK/3jZBI6KvmhSoABYdOw58DvcUVS3IPd
 DeDro8ypn+vFcy8MdAyykNORy5WQz1auyvPSbJKmbkaga8au4RcE9PTvZ7HI
 yv7Djqd/4Xzyxr9VvbBNIGTvc6gm56v+gwMy4xV3t4ntbre5LVhdF5iaiGJ1
 OYW15TTWllMoZPW6ELuj9Vbjtw4EFpMVHl8XGTHjS15v8c1YDCUAVCFwQjra
 dfIFTszh6g81gW/MqJcvrGL8WAhmc30ejEfz+N7f3EAqXmhLvnGhtgbfTEIQ
 wRfsY7Ho6hM96tBALDYzAcDgAFggUDA7FNdn1C4PSWalKco0golFcvj3f/oQ
 pVJ9mVLI60gnimV1CgIEQIJAAmCCEROg2j4I2u6vfbdzJwgBiMo7p8MLWZYN
 Hw+9AgzJQLmU4JJkso95Tv+ld3iPzepxPFCPIEJ8K4+F2QRGxvxQTGVPOJxm
 9O1zYW0phVy69FiSqVq9sa+QS7GClmFJaflfc7loSQLATvR9asTNfV8Ojg9C
 NikdVZAgQipexM2rG3B7LAh02QAAHp8VJ8/0wutXEd3MUz6ttRyrE8m06jMM
 gyUTm/751O3XNS1dkABIh71nz6qS+kroyBBrZ412E5cKBu5+sIn5e3GodgW+
 oArGGEK9dpx8Osx6+pwsvpVHOlZ8oFfLwFvLdhuDIGxuLZh1q/JGNDEblYEx
 rkAe5qpJB2B6UDnQbuKl2QQWZ+LoH/Lg6ef7sW/EC8YZ9h/2Y/9hP5udiOKn
 b8/T4mTsoSRTf2ewmmwgAEHhGZoCpmUgyznnPtmisM6s3opY+e50WkjoAld+
 fB/Td7YwdjzEwvvcYAwYHPNhcMzHlqbjOP+DeZq+GelIMtU7JwYmGBhTwMEM
 AvcBYHL5+IPZJVlm5S1151p1OM04eCyAfSM+7NnrhEVVHrjD6xv24OXfsrHL
 7y7S+f+eg143Z6t5UAa/fQFMkgTX4QROsEoeoPLEHUqmt8+Jp58fwPCYD6zd
 trKm5TIa5iaiWLwXp8XJOCIr6Y4lw6sERAU8sbJhwTgAyAAngsjqWokeJBlF
 4Xjuk4M4+VS47Xa42jZXM5i4skEztyNYm0+BBNUt1N0iEIjARY3Fqf7ZEDoX
 ZKSAayQDFmEQxfRikSDaS8bjs+Bznz8Kb8DaFjQJws1La/jZu4u0vph+hIXa
 WjK1ZEgQBBkckhEDQDIwY+hCmy3l8jIJqiCpH1ziHL/62pFdwUfWMvj+39+h
 tYVUW8t2LBnBmqxefc4XMyAiFjdSsxUCoLQRm3SSm2vZPEyqpWmS0XE/fLuU
 zevLaXzvG1epkC21sfqjS6aRTCafBBjy9xML60B5d0O3oj+aJkbJbDReV4dU
 axmX29IWPAC89Y93qZAptahlqnUMtaxzys/1IDkxcLFz1XlCMMSzGxCk31AU
 oQEgDoDMZrtWEsWfpTe3RG1sr8b3xZkE7UYgm9BQWwC2ju2tJANIjYBrQYv6
 Pk4Mm9n7etHQ3o/FdA0ASQCQy3Uh7OpSeYFe9PXtYYwxgMpFGCMgHStCtSus
 d8DVksDQeIClYgXE1rKVRYbdy4FKYuINktm2PrGa/h0yyUIU84m7UlxE/ngj
 dW0FgKgU9BEqSeaVHmvfF01Wq2J1OJrq9pk7UQDAnkE34w1HI6pdwaFT3ezE
 2T2se8DJvEEVFlWG1apAkhjIIBglUbNQWwOu038DEU4M07FblChsTdzL3PiL
 QiFeBKoJDGDAuPqLgx//ps3u+82DT54pJ7imChTwh1R8/OVBNno8BEl6+NN5
 XTOga+V9hKEL5FIlpLcKWJtOYu7SFq3fSzUvZgFoehHvLJ6jVCn5xcsrt9+o
 nhHVbKk2yGLqmXXLrs+bLCq32mwN4MtkcukS7l5Zx/X3l5FNaTCZJeb0WjrK
 yADAJQ7ZJEE2STBZZNhcJni6VfQd8uLIJ8IstphDbDHX5IEPo9coWtxanU9c
 /4O0Np0tm7P+VMK4tXFxvsfW8+2V6YnXnF6fJEtS26ycSRZx8a15nH9zjhxO
 MwYOeNG7z8X8PTZYbQqsdhN0zYBWNFAqGChkSmWnGgRXwIrwaPP5UGItj/W7
 qUr0wbaU0sU4ZtOTLF1K/elqWqSr4IHmkzlpv++ZroO+E9c8wa5A/+jhthVq
 R7G9toYBQ/deF0ZPh9iRZ8Owe3cOBlKbBVz/r2W6/dYK9JyoWL9MgAThvdX/
 NJLF2MVb6YsvxeNzadQcudd6AACMqejSVpez53dpQ/yH3e1lvkBPh4mplkS5
 HHD7VQyM+TBwyMsGjwZg9+yAjixmMH9lCwtXY7RyKwHotL2wa/V/K/q/lCkl
 sxFEvhCPe3K14FsRADCj3cul3zusvvRnS1N3vmZSzMzh9HZUDviCKvoP+NB/
 0MsGDvrgDlpBgpDYyGN1KonochYbMylauZ1EPqY1ZN2d6MMqBphJTmA2PUlZ
 Sv/O3aV7s8CC3oi27fG61ztkf8Lz89+yStbPDY6d5Da7p6W1rVYJ4f0e9O5z
 QTHJzCgKysSLyESLSG4UkFjLwihSva4bsmtTCCVgPjWF6/HzyJUyf7igX/i7
 jY2NfKP1dyMAAFKf67DzQODM62Zm+eX+4SPc4w7tIpnahISajIoOAO/0gYDJ
 xA18mPyAskbuT+aKd1+PRCaapLMNchcClCxulmIUe8enhK3ZROS0rutwOnxl
 1tsk2E450Jg9q4R2ya5VwpwYdF3Dpcg7YjE7XUpr8d+/vDr7nVzuTkvLd0IA
 AKhQiOvzieL5gOq+axSLz0ejK5KqOrlZtrTOoB0Brr9AwFJ6FucjPzRSpcRK
 XKx/+trKrbeB6cJu4DshULF1RF9OpaY45+esknVPNLo6msnGDIti4xZFbQDc
 XA43Aq6SgSCsZRZxKfKevpCdEnnKfmspO/Xq5Hp8Gpht+jWmVXuYWoABkPz+
 EeuQeuiUU/Z+lUE6azFZ9ZC7X/bYQnBZPJAadd2gcRIGYoVNrGfvYzEzY5So
 SDqVzqVzyW/ciNyYAlaLAIyHAfWwjQMnJL8/Y+lTD+y3c9evqdz8KUHUz5lk
 qCa7YTM7FYtkYRJkgAi60FHQcyKtxfRsKS1XftWZyFH+3GZ+9dzcVmoFuFUF
 /kCrPy6B2m8lIKy4XNwStg53u0yBpyTGRySmDHMwH2PMAYIgJlIlQ9sQRNMa
 FSc20ysXU3wrFo+LIrBQwiP8j8RHQaB2jMo4JyQgKgVgkw1vkQuhc8Y4McYp
 FksbgEMHZowGwI8EvNr+D2Go6X13krXsAAAAAElFTkSuQmCC

Package: emacs25-el
Architecture: all
Depends: emacs25 (= ${source:Version}), ${misc:Depends}
Description: GNU Emacs LISP (.el) files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the elisp sources for the convenience of users,
 saving space in the main package for small systems.
XSBC-Maemo-Display-Name: GNU Emacs LISP files
XSBC-Bugtracker: https://talk.maemo.org/showthread.php?t=88135

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)

export DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

src_name := emacs25

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --prefix=/opt/$(src_name) --with-modules

override_dh_install:
	# Move LISP source files to separate package
	install -d $(CURDIR)/debian/$(src_name)-el
	(cd $(CURDIR)/debian/tmp && find -name "*.el.gz" -print0 \
           | tar cpf - --null --files-from -) \
             | (cd debian/$(src_name)-el && tar xpf -)
	find debian/tmp -name "*.el.gz" -exec rm '{}' \;
	# Move the rest into the main binary package
	rm -r debian/tmp/var
	install -d $(CURDIR)/debian/$(src_name)
	mv debian/tmp/* debian/$(src_name)
	dh_install
	
override_dh_installdocs:
override_dh_installman:
override_dh_installchangelogs:
